# coding: utf-8

"""
    Aladdin User Group

    API contains operations on Aladdin User Group resource. Note: This is not intended to be used for Authorization.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from asdk_plugin_platform.agraph.platform.access.user_group.v1.UserGroupAPI.models.v1_node_type import V1NodeType

class V1UserGroup(BaseModel):
    """
    UserGroup describes User Group resource in Aladdin.
    """
    id: StrictStr = Field(..., description="The name of the User Group.")
    group_description: StrictStr = Field(..., alias="groupDescription", description="The description of the User Group.")
    root_group_id: Optional[StrictStr] = Field(None, alias="rootGroupId", description="The Root User Group - for User Groups of Node Type G, a Root User Group must be supplied.")
    node_type: Optional[V1NodeType] = Field(None, alias="nodeType")
    auth_user_group: Optional[StrictStr] = Field(None, alias="authUserGroup", description="The Authorization User Group.  Authorization is the process of giving someone permission to do or have something. These auth groups contain a list of users who can approve changes. Must respect the enforced naming policy based on the environment.")
    parent_user_group_id: Optional[StrictStr] = Field(None, alias="parentUserGroupId", description="The Parent User Group - for User Groups of Node Type G, a Parent User Group must be supplied.")
    __properties = ["id", "groupDescription", "rootGroupId", "nodeType", "authUserGroup", "parentUserGroupId"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1UserGroup:
        """Create an instance of V1UserGroup from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1UserGroup:
        """Create an instance of V1UserGroup from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1UserGroup.parse_obj(obj)

        _obj = V1UserGroup.parse_obj({
            "id": obj.get("id"),
            "group_description": obj.get("groupDescription"),
            "root_group_id": obj.get("rootGroupId"),
            "node_type": obj.get("nodeType"),
            "auth_user_group": obj.get("authUserGroup"),
            "parent_user_group_id": obj.get("parentUserGroupId")
        })
        return _obj

